#!/usr/bin/perl

use Astro::VO::VOTable;
use Astro::VO::VOTable::Document;

# Affiche le contenu d'un document VOTable (metadata+data)
# On se limite  l'affichage de la premire TABLE de chaque RESOURCE

my($doc);
my($votable);
my($resource);
my($table);
my($data);
my($tabledata);
my($num_rows);
my(@fields);
my($field);
my(@resources);
my($num_res);
my($num_cols);
my($tr);
my($td);
my($i, $j, $k);

$doc = Astro::VO::VOTable::Document->new_from_file($ARGV[0]) or die "Entrez le nom d'un fichier VOTable comme argument";
$votable = $doc->get_VOTABLE or die;
@resources = $votable->get_RESOURCE;
$num_res = @resources;

# On parcourt l'ensemble des RESOURCE
for( $i=0; $i<$num_res; $i++ ) {
	$resource = $resources[$i];
	print "Resource $i :\n";
	# Pour chaque resource, on va rcuprer la premire table
	$table = $resource->get_TABLE(0) or die;
	@fields = $table->get_FIELD;
	$num_cols = @fields;
	$data = $table->get_DATA or die;
	$tabledata = $data->get_TABLEDATA or die;
	$num_rows = $table->get_num_rows or die;

	print "\n*** Info sur les mtadonnes ***\n";
	# Affichage des champs (FIELD)
	print "Nb FIELD : $num_cols\n";
	foreach $field (@fields) {
		print "FIELD ".$field->get_name;
		# A COMPLETER : ajouter l'affichage de l'UCD et de l'unit du champ courant
		# ...
		print "\n";
	}

	print "********************************\n";
	
	# Affichage des donnes
	print "\n*** Donnes ***\n";
	# Boucle sur les lignes
	for( $j=0; $j<$num_rows; $j++ ) {
		$tr = $tabledata->get_TR($j) or die;
		# Boucle sur les cellules d'une ligne
		for ($k = 0; $k < $num_cols; $k++) {
		 	$td = $tr->get_TD($k);
			print $td->get."\t";
		}
		print "\n";
	}
	print "***************\n";

	print "\n \n \n";
}
